> For the complete documentation index, see [llms.txt](https://developers.oxylabs.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.oxylabs.io/api-targets/search-engines/google/travel-hotels.md).

# Travel: Hotels

The `google_travel_hotels` data source is designed to retrieve Google Travel service's hotel search results.

{% hint style="warning" %}
To ensure optimal utilization of this service, include the `"render": "html"` parameter in your request.
{% endhint %}

## Request samples

In this example, we make a request to retrieve the `2`nd results page for hotel availability for `2` adult guests between `2023-10-01` and `2023-10-10` for `2` to `4`-star hotels in Paris from `google.com`.

{% tabs %}
{% tab title="cURL" %}

```shell
curl 'https://realtime.oxylabs.io/v1/queries' \
--user 'USERNAME:PASSWORD' \
-H 'Content-Type: application/json' \
-d '{
        "source": "google_travel_hotels",
        "start_page": 2,
        "query": "hotels in Paris",
        "render": "html",
        "parse": true,
        "context": [
            {"key": "adults", "value": 2},
            {"key": "hotel_dates", "value": "2023-10-01,2023-10-10"},
            {"key": "hotel_classes", "value": [2, 3, 4]}
        ]
    }'
```

{% endtab %}

{% tab title="Python" %}

```python
import requests
from pprint import pprint

# Structure payload.
payload = {
  "source": "google_travel_hotels",
  "query": "hotels in Paris",
  "start_page": 2,
  "render": "html",
  "parse": True,
  "context": [
    {
      "key": "adults",
      "value": 1
    },
    {
      "key": "hotel_dates",
      "value": "2023-10-01,2023-10-10"
    },
    {
      "key": "hotel_classes",
      "value": [2, 3, 4]
    }
  ]
}

# Get response.
response = requests.request(
    'POST',
    'https://realtime.oxylabs.io/v1/queries',
    auth=('USERNAME', 'PASSWORD'),
    json=payload,
)

# Print prettified response to stdout.
pprint(response.json())
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const https = require("https");

const username = "USERNAME";
const password = "PASSWORD";
const body = {
    source: "google_travel_hotels",
    start_page: 2,
    query: "hotels in Paris",
    render: "html",
    parse: true,
    context: [
        { key: "adults", value: 2 },
        { key: "hotel_dates", value: "2023-10-01,2023-10-10" },
        { key: "hotel_classes", value: [2, 3, 4] },
    ],
};

const options = {
    hostname: "realtime.oxylabs.io",
    path: "/v1/queries",
    method: "POST",
    headers: {
        "Content-Type": "application/json",
        Authorization:
            "Basic " + Buffer.from(`${username}:${password}`).toString("base64"),
    },
};

const request = https.request(options, (response) => {
    let data = "";

    response.on("data", (chunk) => {
        data += chunk;
    });

    response.on("end", () => {
        const responseData = JSON.parse(data);
        console.log(JSON.stringify(responseData, null, 2));
    });
});

request.on("error", (error) => {
    console.error("Error:", error);
});

request.write(JSON.stringify(body));
request.end();
```

{% endtab %}

{% tab title="HTTP" %}

```http
https://realtime.oxylabs.io/v1/queries?source=google_travel_hotels&query=hotels+in+Paris&start_page=3&render=html&parse=true&context[0][key]=adults&context[0][value]=1&context[1][key]=hotel_dates&context[1][value]=2023-10-01,2023-10-10&context[2][key]=hotel_classes&context[2][value]=[2,3,4]&access_token=12345abcde
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php

$params = array(
    'source' => 'google_travel_hotels',
    'start_page' => 2,
    'query' => 'hotels in Paris',
    'render' => 'html',
    'parse' => true,
    'context' => [
        ['key' => 'adults', 'value' => 2],
        ['key' => 'hotel_dates', 'value' => '2023-10-01,2023-10-10'],
        ['key' => 'hotel_classes', 'value' => [2, 3, 4]]
    ]
);

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, "https://realtime.oxylabs.io/v1/queries");
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($params));
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_USERPWD, "USERNAME" . ":" . "PASSWORD");


$headers = array();
$headers[] = "Content-Type: application/json";
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
echo $result;

if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
```

{% endtab %}

{% tab title="Golang" %}

```go
package main

import (
	"bytes"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"net/http"
)

func main() {
	const Username = "USERNAME"
	const Password = "PASSWORD"

	payload := map[string]interface{}{
		"source":     "google_travel_hotels",
		"start_page": 2,
		"query":      "hotels in Paris",
		"render":     "html",
		"parse":			true,
		"context": []map[string]interface{}{
			{"key": "adults", "value": 2},
			{"key": "hotel_dates", "value": "2023-10-01,2023-10-10"},
			{"key": "hotel_classes", "value": []interface{}{2, 3, 4}},
		},
	}

	jsonValue, _ := json.Marshal(payload)

	client := &http.Client{}
	request, _ := http.NewRequest("POST",
		"https://realtime.oxylabs.io/v1/queries",
		bytes.NewBuffer(jsonValue),
	)

	request.SetBasicAuth(Username, Password)
	response, _ := client.Do(request)

	responseText, _ := ioutil.ReadAll(response.Body)
	fmt.Println(string(responseText))
}
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;

namespace OxyApi
{
    class Program
    {
        static async Task Main()
        {
            const string Username = "USERNAME";
            const string Password = "PASSWORD";

            var parameters = new {
                source = "google_travel_hotels",
                start_page = 2,
                query = "hotels in Paris",
                render = "html",
                parse = true,
                context = new dynamic [] {
                    new { key = "adults", value = 2 },
                    new { key = "hotel_dates", value = "2023-10-01,2023-10-10" },
                    new { key = "hotel_classes", value = new int [] {2, 3, 4} }
                }
            };

            var client = new HttpClient();

            Uri baseUri = new Uri("https://realtime.oxylabs.io");
            client.BaseAddress = baseUri;

            var requestMessage = new HttpRequestMessage(HttpMethod.Post, "/v1/queries");
            requestMessage.Content = JsonContent.Create(parameters);

            var authenticationString = $"{Username}:{Password}";
            var base64EncodedAuthenticationString = Convert.ToBase64String(System.Text.ASCIIEncoding.UTF8.GetBytes(authenticationString));
            requestMessage.Headers.Add("Authorization", "Basic " + base64EncodedAuthenticationString);

            var response = await client.SendAsync(requestMessage);
            var contents = await response.Content.ReadAsStringAsync();

            Console.WriteLine(contents);
        }
    }
}
```

{% endtab %}

{% tab title="Java" %}

```java
package org.example;

import okhttp3.*;
import org.json.JSONArray;
import org.json.JSONObject;
import java.util.concurrent.TimeUnit;

public class Main implements Runnable {
    private static final String AUTHORIZATION_HEADER = "Authorization";
    public static final String USERNAME = "USERNAME";
    public static final String PASSWORD = "PASSWORD";

    public void run() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("source", "google_travel_hotels");
        jsonObject.put("start_page", 2);
        jsonObject.put("query", "hotels in Paris");
        jsonObject.put("render", "html");
        jsonObject.put("parse", true);
        jsonObject.put("context", new JSONArray()
                .put(new JSONObject().put("key", "adults").put("value", 2))
                .put(new JSONObject().put("key", "hotel_dates").put("value", "2023-10-01,2023-10-10"))
                .put(new JSONObject().put("key", "hotel_classes").put("value", new JSONArray().put(2).put(3).put(4)))
        );

        Authenticator authenticator = (route, response) -> {
            String credential = Credentials.basic(USERNAME, PASSWORD);
            return response
                    .request()
                    .newBuilder()
                    .header(AUTHORIZATION_HEADER, credential)
                    .build();
        };

        var client = new OkHttpClient.Builder()
                .authenticator(authenticator)
                .readTimeout(180, TimeUnit.SECONDS)
                .build();

        var mediaType = MediaType.parse("application/json; charset=utf-8");
        var body = RequestBody.create(jsonObject.toString(), mediaType);
        var request = new Request.Builder()
                .url("https://realtime.oxylabs.io/v1/queries")
                .post(body)
                .build();

        try (var response = client.newCall(request).execute()) {
            if (response.body() != null) {
                try (var responseBody = response.body()) {
                    System.out.println(responseBody.string());
                }
            }
        } catch (Exception exception) {
            System.out.println("Error: " + exception.getMessage());
        }

        System.exit(0);
    }

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }
}
```

{% endtab %}

{% tab title="JSON" %}

```json
{
    "source": "google_travel_hotels",
    "start_page": 2, 
    "query": "hotels in Paris",
    "render": "html", 
    "parse": true,
    "context": [
        {
            "key": "adults", 
            "value": 2
        }, 
        {
            "key": "hotel_dates", 
            "value": "2023-10-01,2023-10-10"
        },
        {
            "key": "hotel_classes", 
            "value": [2,3,4]
        }
    ]
}
```

{% endtab %}
{% endtabs %}

We use synchronous [**Realtime**](/products/web-scraper-api/integration-methods/realtime.md) integration method in our examples. If you would like to use [**Proxy Endpoint**](/products/web-scraper-api/integration-methods/proxy-endpoint.md) or asynchronous [**Push-Pull**](/products/web-scraper-api/integration-methods/push-pull.md) integration, refer to the [**integration methods**](/products/web-scraper-api/integration-methods.md) section.

## Request parameters

### Generic

<table><thead><tr><th width="164">Parameter</th><th width="471.3333333333333">Description</th><th width="116">Default Value</th></tr></thead><tbody><tr><td><mark style="background-color:green;"><strong><code>source</code></strong></mark></td><td>Sets the scraper. Use <code>google_travel_hotels</code>.</td><td>–</td></tr><tr><td><mark style="background-color:green;"><strong><code>query</code></strong></mark></td><td><p>Search term for request. <code>"query": "hotels"</code> will return a list of hotels in a given <code>geo_location</code>.</p><p><code>"query": "hotels in &#x3C;Location>"</code> will return a list of hotels for <code>&#x3C;Location></code>. (e.g. <code>"query": "hotels in Paris"</code> will list hotels in Paris, regardless of <code>geo_location</code>)</p></td><td>–</td></tr><tr><td><strong><code>render</code></strong></td><td>Enables JavaScript rendering when set to <code>html</code>. <a href="/spaces/BQ7Zf9paoN3FTeGcyfY1/pages/pGs7q0aw7gpLmDsoGTdt#javascript-rendering"><strong>More info</strong></a><strong>.</strong></td><td>–</td></tr><tr><td><code>parse</code></td><td>Returns parsed data when set to <code>true</code>. See more in <strong>data dictionary</strong>.</td><td><code>false</code></td></tr><tr><td><code>callback_url</code></td><td>URL to your callback endpoint. <a href="/spaces/BQ7Zf9paoN3FTeGcyfY1/pages/DijMC0XcEbNczNgRaHIV"><strong>More info</strong></a></td><td>–</td></tr><tr><td><code>user_agent_type</code></td><td>Device type and browser. The full list can be found <a href="/spaces/BQ7Zf9paoN3FTeGcyfY1/pages/rrKXR4LNzotP94phU1YL"><strong>here</strong></a>.</td><td><code>desktop</code></td></tr></tbody></table>

&#x20;   \- mandatory parameter

### Localization

Adapt search results to specific geographical locations and languages.

<table><thead><tr><th width="222">Parameter</th><th width="350.3333333333333">Description</th><th>Default Value</th></tr></thead><tbody><tr><td><code>geo_location</code></td><td>The geographical location that the result should be adapted for. <strong>Using this parameter correctly is extremely important to get the right data.</strong> Please note that this source can accept a limited number of <code>geo_location</code> values - please check <a href="/spaces/BQ7Zf9paoN3FTeGcyfY1/pages/MzPAMWq8tFiQFjuZRyEM#google-travel-hotels"><strong>this section</strong></a> to see <code>geo_location</code> values that <strong>don't</strong> yield accurate results.</td><td>-</td></tr><tr><td><code>locale</code></td><td><code>Accept-Language</code> header value which changes your Google search page web interface language. <a href="/spaces/BQ7Zf9paoN3FTeGcyfY1/pages/rAkVD7OwCRtmZreOVBiG#locale-1"><strong>More info</strong></a>.</td><td>-</td></tr></tbody></table>

{% hint style="info" %}
**NOTE:** `"geo_location": "United States"` and other wide-area locations are not supported. Use city-level `geo_location`, e.g., `Seattle,Washington,United States`
{% endhint %}

### Pagination

<table><thead><tr><th width="222">Parameter</th><th width="350.3333333333333">Description</th><th width="167">Default Value</th></tr></thead><tbody><tr><td><code>start_page</code></td><td>Starting page number.</td><td><code>1</code></td></tr></tbody></table>

### Filtering

Advanced options for tailoring and refining the search context.

<table><thead><tr><th width="222">Parameter</th><th width="350.3333333333333">Description</th><th>Default Value</th></tr></thead><tbody><tr><td><code>context:adults</code></td><td>Number of adult guests</td><td><code>2</code></td></tr><tr><td><code>context:children</code></td><td>Number of children guests</td><td>-</td></tr><tr><td><code>context</code>:<br><code>hotel_classes</code></td><td>Filter results by # of hotel stars. You may specify one or more values between <code>2</code> and <code>5</code>. Example: <code>[3,4]</code></td><td>-</td></tr><tr><td><code>context</code>:<br><code>hotel_dates</code></td><td>Dates for staying at the hotel, from - to. Example: <code>2023-07-12,2023-07-13</code></td><td>-</td></tr></tbody></table>

All context parameters should be used in the `context` array as objects with `key` and `value` pairs:

```json
...
"context": [
    {
        "key": "filter",
        "value": "0"
    }
]
...
```

## Structured data

Web Scraper API can extract results HTML or JSON response that contains structured data on various elements of the results page.

<details>

<summary>Structured <code>google_travel_hotels</code> output (JSON)</summary>

```json
{
    "results": [
        {
            "content": {
                "url": "https://www.google.com/travel/search?q=hotels+in+Spain&qs=OAA&hl=en&gl=us",
                "page": 1,
                "parse_status_code": 12000,
                "last_visible_page": -1,
                "results": {
                    "offers": [
                        {
                            "pos": 1,
                            "type": "hotel",
                            "name": "El Oceano Beach Hotel & Restaurant",
                            "description": "Refined property opposite the beach, plus a restaurant, an outdoor pool & 2 bars.",
                            "property_token": "ChcImqqwzb7WqI51GgsvZy8xdGZ2MXhxNBAB",
                            "hotel_class": {
                                "stars": 4,
                                "label": "4-star hotel"
                            },
                            "rating": {
                                "overall": 4.6,
                                "reviews": 1303
                            },
                            "deal": {
                                "label": "GREAT DEAL",
                                "description": "31% less than usual"
                            },
                            "eco_certified": true,
                            "pricing": {
                                "price": { "amount": 311, "currency": "USD" },
                                "price_with_tax": { "amount": 342, "currency": "USD" },
                                "total_price": { "amount": 311, "currency": "USD" },
                                "total_price_with_tax": { "amount": 342, "currency": "USD" }
                            },
                            "check_in_time": "2:00 PM",
                            "check_out_time": "12:00 PM",
                            "coordinates": {
                                "latitude": 36.4909496,
                                "longitude": -4.6948331
                            },
                            "amenities": [
                                "Breakfast ($)",
                                "Free Wi-Fi",
                                "Free parking",
                                "Pools",
                                "Hot tub",
                                "Air conditioning",
                                "Fitness center",
                                "Spa"
                            ],
                            "images": [
                                {
                                    "thumbnail_url": "https://lh3.googleusercontent.com/gps-cs-s/AC9h...=s287-w287-h192-n-k-no-v1",
                                    "original_url": "https://lh3.googleusercontent.com/gps-cs-s/AC9h..."
                                },
                                {
                                    "thumbnail_url": "https://lh3.googleusercontent.com/gps-cs-s/AB7n...=s287-w287-h192-n-k-no-v1",
                                    "original_url": "https://lh3.googleusercontent.com/gps-cs-s/AB7n..."
                                }
                            ],
                            "nearby_places": [
                                {
                                    "category_id": 1,
                                    "name": "Cabopino Beach",
                                    "transport_mode_id": 0,
                                    "travel_time": "9 min"
                                },
                                {
                                    "category_id": 3,
                                    "name": "Málaga-Costa del Sol Airport",
                                    "transport_mode_id": 0,
                                    "travel_time": "29 min"
                                }
                            ],
                            "website_url": "https://www.oceanohotel.com/",
                            "details_url": "https://www.google.com/travel/hotels/entity/ChcImqqwzb7WqI51GgsvZy8xdGZ2MXhxNBAB?q=hotels+in+Spain&hl=en&gl=us",
                            "reviews_url": "https://www.google.com/travel/hotels/entity/ChcImqqwzb7WqI51GgsvZy8xdGZ2MXhxNBAB/reviews?q=hotels+in+Spain&hl=en&gl=us"
                        },
                        {
                            "pos": 2,
                            "type": "hotel",
                            "name": "Apartamentos Vista del Mar",
                            "property_token": "ChkQ5Nm9m7SusuhsGg0vZy8xMXlzNjB6bGtsEAI",
                            "rating": {
                                "overall": 4.2,
                                "reviews": 642
                            },
                            "pricing": {
                                "price": { "amount": 96, "currency": "USD" },
                                "price_with_tax": { "amount": 105, "currency": "USD" },
                                "total_price": { "amount": 96, "currency": "USD" },
                                "total_price_with_tax": { "amount": 105, "currency": "USD" }
                            },
                            "check_in_time": "3:00 PM",
                            "check_out_time": "12:00 PM",
                            "coordinates": {
                                "latitude": 36.4363785,
                                "longitude": -5.1079798
                            },
                            "amenities": [
                                "Apartment",
                                "Sleeps 10",
                                "19 bedrooms",
                                "10 bathrooms",
                                "Airport shuttle",
                                "Outdoor pool",
                                "Free Wi-Fi"
                            ],
                            "images": [
                                {
                                    "thumbnail_url": "https://lh6.googleusercontent.com/proxy/Qnw3...=s287-w287-h192-n-k-no-v1",
                                    "original_url": "https://lh6.googleusercontent.com/proxy/Qnw3..."
                                }
                            ],
                            "nearby_places": [
                                {
                                    "category_id": 3,
                                    "name": "Alicante Airport",
                                    "transport_mode_id": 0,
                                    "travel_time": "18 min"
                                }
                            ],
                            "website_url": "http://www.hotellosangelesdenia.com/",
                            "details_url": "https://www.google.com/travel/hotels/entity/ChkQ5Nm9m7SusuhsGg0vZy8xMXlzNjB6bGtsEAI?q=hotels+in+Spain&hl=en&gl=us",
                            "reviews_url": "https://www.google.com/travel/hotels/entity/ChkQ5Nm9m7SusuhsGg0vZy8xMXlzNjB6bGtsEAI/reviews?q=hotels+in+Spain&hl=en&gl=us"
                        }
                        // ... up to 18 more offers
                    ],
                    "overview": {
                        "country": "us",
                        "language": "en",
                        "total_results": 15000
                    },
                    "pagination": {
                        "current_from": 1,
                        "current_to": 20
                    }
                }
            },
            "created_at": "2026-06-17 14:23:22",
            "updated_at": "2026-06-17 14:23:26",
            "page": 1,
            "url": "https://www.google.com/travel/search?q=hotels+in+Spain&qs=OAA&hl=en&gl=us",
            "job_id": "7473017451119126529",
            "status_code": 200
        }
    ]
}
```

</details>

## Output dictionary

The table below presents a detailed list of each top-level element we parse, along with its description and data type.

{% hint style="info" %}
The number of offers and certain fields may vary depending on the search query and property.
{% endhint %}

<table data-full-width="false"><thead><tr><th width="199">Key</th><th width="421">Description</th><th width="107">Type</th></tr></thead><tbody><tr><td><code>url</code></td><td>URL to the Google Travel hotel search page.</td><td>string</td></tr><tr><td><code>page</code></td><td>Current page number of the search results.</td><td>integer</td></tr><tr><td><code>last_visible_page</code></td><td>Maximum page number visible in the results page.</td><td>integer</td></tr><tr><td><code>parse_status_code</code></td><td>The status code of the parsing job. Learn more <a href="https://developers.oxylabs.io/scraper-apis/web-scraper-api/response-codes#parsers"><strong>here</strong></a>.</td><td>integer</td></tr><tr><td><code>results</code></td><td>Object containing the parsed hotel search results.</td><td>object</td></tr><tr><td><code>results.offers</code></td><td>List of hotel offers returned for the query. Includes <code>pos</code>, <code>name</code>, <code>description</code>, <code>property_token</code>, <code>hotel_class</code>, <code>rating</code>, <code>deal</code>, <code>eco_certified</code>, <code>pricing</code>, <code>check_in_time</code>, <code>check_out_time</code>, <code>coordinates</code>, <code>amenities</code>, <code>images</code>, <code>nearby_places</code>, <code>website_url</code>, <code>details_url</code>, <code>reviews_url</code>.</td><td>array</td></tr><tr><td><code>results.overview</code></td><td>General details about the search results. Includes <code>country</code>, <code>language</code>, <code>total_results</code>.</td><td>object</td></tr><tr><td><code>results.pagination</code></td><td>Details about the current page of results. Includes <code>current_from</code>, <code>current_to</code>.</td><td>object</td></tr><tr><td><code>created_at</code></td><td>Timestamp when the scraping job was created.</td><td>timestamp</td></tr><tr><td><code>updated_at</code></td><td>Timestamp when the scraping job was finished.</td><td>timestamp</td></tr><tr><td><code>job_id</code></td><td>ID of the job associated with the scraping job.</td><td>string</td></tr><tr><td><code>status_code</code></td><td>Status code of the scraping job. Learn more <a href="/spaces/BQ7Zf9paoN3FTeGcyfY1/pages/PpAgJ3odBUGijPxHsnTV"><strong>here</strong></a>.</td><td>integer</td></tr></tbody></table>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers.oxylabs.io/api-targets/search-engines/google/travel-hotels.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
